﻿<?xml version="1.0" encoding="utf-8"?>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd">
    <head>
        <link href="../Resources/TableStyles/Default-Table.css" rel="stylesheet" MadCap:stylesheetType="table" /><title>Uploading a Technical Rule</title>
        <link href="../Resources/Stylesheets/Styles.css" rel="stylesheet" type="text/css" />
    </head>
    <body>
        <h1>Uploading a Technical Rule</h1>
        <p>Technical rules are uploaded to EIC through a file-based import.</p>
        <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
            <p class="note">By default, the <strong>Upload Technical Rule</strong>&#160;option is not displayed under <strong>Actions</strong>. To display it, enable <strong>Enable Upload Rule Feature </strong>from <strong>Global Configurations &gt; Identity Access Rules</strong>. Note that this option is not currently working as expected on EIC 5.5 SP3.x and EIC 2020.x versions.</p>
        </div>
        <p>To upload a Technical rule, perform the following steps:</p>
        <ol>
            <li>Go to <strong>ADMIN &gt; Policies &gt; Technical Rule &gt; Actions</strong>.</li>
            <li>Select <strong>Upload Technical Rules</strong>.</li>
            <li>
                <p class="auto-cursor-target">In the&#160;pop-up window that displays, select <strong>Data File</strong>&#160;(JSON file) to upload the file.&#160;<br />Below is a sample JSON:</p>
                <div class="warning" MadCap:autonum="&lt;b&gt;Warning&lt;/b&gt;">
                    <p class="note">For Technical Rule, you need to specify the type as '1', while for User Update Rule, you need to specify the type as '2' in the sample JSON that is used for upload.</p>
                </div>
                <p>&#160;</p>
                <p>
                    <MadCap:codeSnippet>
                        <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
                        <MadCap:codeSnippetCaption>JSON</MadCap:codeSnippetCaption>
                        <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">[
  {
    "type": 1,
    "description": Sample Rule,
    "advancedConfig": false,
    "preventative": null,
    "removeBirthRightOnFail": false,
    "actionType": null,
    "advancedQuery": null,
    "birthRight": false,
    "name": "tech rule by upload",
    "rolename": null,
    "ruledescription": "",
    "invokebyDetectiveJob": false,
    "evaluateHierarchy": false,
    "detective": false,
    "packagename": "",
    "updateuserId": 354985,
    "totalusers": 0,
    "usersinsap": 0,
    "ownerKey": null,
    "eventSource": null,
    "totalviolations": 0,
    "totalanalyticalprivileges": 0,
    "createuser": 354985,
    "sentForApproval": false,
    "ownerType": null,
    "status": 0,
    "attributes": [
      {
        "nextrulecondition": "AND",
        "conditionopertor": "EQUAL",
        "conditionoraction": "COND",
        "objectname": "Users",
        "objectvaluetype": "1",
        "objectattribute": "middlename",
        "position": 0,
        "scehemaname": "",
        "objectvalue": "minarul",
        "objecttype": "User"
      },
      {
        "nextrulecondition": "AND",
        "conditionopertor": null,
        "conditionoraction": "ACTN",
        "objectattribute": "Assign",
        "objectvalue": null,
        "objectvaluetype": 1,
        "position": 1,
        "scehemaname": "",
        "objectname": "-999",
        "objecttype": "EP_37"
      },
      {
        "nextrulecondition": "AND",
        "conditionopertor": null,
        "conditionoraction": "ACTN",
        "objectattribute": "Assign",
        "objectvalue": null,
        "objectvaluetype": 1,
        "position": 2,
        "scehemaname": "",
        "objectname": "CN=sav_manager,OU=Groups,OU=NM,OU=IndiaFO,DC=corpAD,DC=saviynt,DC=com",
        "objecttype": "93"
      }
    ]
  }
]</MadCap:codeSnippetBody>
                    </MadCap:codeSnippet>
                    <p>&#160;</p>
                </p>
            </li>
            <li>Click <strong>Upload</strong>. The Technical rule is displayed with parameters such as Name, Detail, Status, and Action.&#160;</li>
            <li>The <strong>Action</strong> column provides you the options icons for editing, enabling, or deleting the rule.&#160;</li>
            <li>When you click the&#160;<strong>Edit&#160;</strong>icon, it takes you to the Rule Details page for the rule.</li>
            <li>Select the conditions for your requirements and click <strong>Send For Approval</strong>.</li>
            <li>After the rule is approved, you can view the newly created technical rule details in <strong>Technical Rule</strong>.</li>
        </ol>
        <h2>Creating Technical Rule</h2>
        <p>To create a technical rule, perform the following steps:</p>
        <ol>
            <li>Go to <strong>ADMIN &gt; Policies &gt; Technical Rule</strong><br />&#160;The&#160;<strong>Technical Rules</strong> page is displayed.</li>
            <li>
                <p>Click&#160;<b>Actions &gt;&#160;Create Technical Rules</b>.<br />The&#160;<strong>Create Technical Rule</strong> page is displayed.</p>
            </li>
            <li>Provide values for the <b>Create Technical Rule</b> parameters and click Send for Approval.<p>The values in the parameters marked with an asterisk (*) are mandatory.</p><table class="TableStyle-Default-Table" style="width: 100%;mc-table-style: url('../Resources/TableStyles/Default-Table.css');" cellspacing="0"><col class="TableStyle-Default-Table-Column-Column1" /><col class="TableStyle-Default-Table-Column-Column1" /><thead><tr class="TableStyle-Default-Table-Head-Header1"><th class="TableStyle-Default-Table-HeadE-Column1-Header1">Parameter</th><th class="TableStyle-Default-Table-HeadD-Column1-Header1">Description</th></tr></thead><tbody><tr class="TableStyle-Default-Table-Body-Body1"><th colspan="2" style="text-align: left;" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Rule Details</p></th></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">Enter Rule Name</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Enter the appropriate rule name.</p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">Rule Description</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Enter the appropriate rule description.</p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td class="TableStyle-Default-Table-BodyD-Column1-Body1" style="text-align: left;" colspan="2"><p class="table-text"><strong>Rule Owner</strong> - To add rule owner, click <strong>+Add Rule Owner</strong> and select one or more rule owner names. The rule owner details appear in the following columns.</p><p class="table-text">Identity Access Rules defined are displayed for Rule Owners and Admin users only. This enforces security and regulates control on rules only to users who should govern modification to the rules.</p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">User name</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Displays the user name of the rule owner.</p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">Rank</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Displays the rank of the rule owner. You can update the Rule Owner Rank as per your requirement. The benefit of specifying Rule Owner is that it provides you the capability to send the Rule Approval to specific Rank owners using a custom query defined in the workflow. Using Workflow, you can specify to which Rank Owners the Rule should be sent for approval.</p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">First name</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Displays the first name of the rule owner.</p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">Last name</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Displays the last name of the rule owner</p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">City</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Displays the name of the city.</p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">Email</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Displays the email id of the rule owner.</p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">Comments</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Displays the comments specified for the user from the User show page. The comments field is extracted from the User show page metadata.</p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">End date</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Displays the end date specified for the user from the User show page.&#160;The End Date field is extracted from the User show page metadata.</p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><th colspan="2" style="text-align: left;" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Condition</p></th></tr><tr class="TableStyle-Default-Table-Body-Body1"><td class="TableStyle-Default-Table-BodyD-Column1-Body1" colspan="2"><p class="table-text">Advanced Config ON - If you need to write complex queries that have multiple AND and OR conditions, it is recommended to set&#160;Advanced Config ON and specify conditions using the query as the UI does not support multiple conditions.</p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">Advanced Query</p></td><td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Select <strong>Advanced Config</strong> as ON to write complex multiple queries as the condition for triggering the Technical Rule.&#160;</p><p class="table-text">The user attributes specified in the <strong>Advanced Config</strong> query are case-sensitive. The supported user attributes to be used in the Advanced Config are as follows:</p><span class="attr">username,firstname,preferedFirstName,lastname,middlename,street,city,comments,statuskey,startdate,enddate,manager,password,location,jobCode,jobDescription,employeeType,
systemUserName,departmentNumber,title,state,companyname,costcenter,departmentname,employeeclass,entity,jobcodedesc,locationdesc,locationnumber,siteid,orgunitid,region,regioncode,
owner,employeeid,lastsyncdate,createdate,email,phonenumber,job_function,country,displayname,locale,customproperty1-65</span><p class="table-text">Example to filter</p><ul><li><p class="table-text">users who are 'Employee' AND</p></li><li><p class="table-text">active in EIC AND</p></li><li><p class="table-text">created date same as system date AND</p></li><li><p class="table-text">systemusernmae not null AND</p></li><li><p class="table-text">customproperty12 value null</p></li></ul><p class="table-text">Example query:</p><p class="table-text"><span class="attr">a.employeeclass = 'Employee' AND a.statuskey=1 AND date(a.createdate) = date(sysdate()) AND a.systemUserName is not null and a.customproperty12 is null</span></p><p class="table-text">Example query:</p><p class="table-text"><span class="attr">employeeclass='Contractor' and date(FROM_UNIXTIME(substr(a.customproperty6,7,10))) &lt;= date(sysdate()) and (a.customproperty11 is null OR upper(a.customproperty11) != 'YES')</span></p><ul><li><p class="table-text">users who are 'Contractor' with additional conditions<br /></p></li></ul></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td class="TableStyle-Default-Table-BodyD-Column1-Body1" colspan="2"><p class="table-text">Advanced Config OFF -&#160;To add additional conditions, click <strong>+Add Condition</strong> and fill in values for the parameters.</p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">(,((</p><p class="table-text">(Available from Release v2021.0 onwards)</p></td><td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Select the required open parenthesis.&#160;</p><div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;"><p class="note">The open and close parenthesis allow you to create complex queries from the basic query condition option from the user interface.</p></div></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">Object</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Select the appropriate object name.&#160;</p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">Attribute</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Select the appropriate attribute.&#160;For example, user attribute and the condition for the chosen attribute and the value of the user attribute is checked against. (For example: Users.id Greater than 0 – id is the attribute, greater than is the condition and 0 is the value).</p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">Condition</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">The condition is used to designate whether the Attribute selected should be 'equals', 'less than', 'greater than', 'starts with', etc for the value specified.</p><p class="table-text"><strong>Example to filter different user types (Employee, Contractors, Intern)&#160;</strong></p><p class="table-text">To filter employee types such as Employee, Contractor, or Intern, you need to use the attribute employeeclass with 'in' condition and value as 'Employee,Contractor,Intern". The following screen also displays additional conditions such as users status as active (1) in EIC.</p><p class="table-text"><img src="../Resources/Images/Example to filter different user types.png" style="border-left-style: solid;border-left-width: 1px;border-left-color: ;border-right-style: solid;border-right-width: 1px;border-right-color: ;border-top-style: solid;border-top-width: 1px;border-top-color: ;border-bottom-style: solid;border-bottom-width: 1px;border-bottom-color: ;width: 700px;height: 300px;" /></p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">Value</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Specify the appropriate value. For example,&#160;sysdate() OR DATE_ADD(curdate(),INTERVAL 1 DAY) OR DATE_SUB(curdate(),INTERVAL 1 DAY)</p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p colspan="1" class="table-text">),))</p><p colspan="1" class="table-text">(Available from Release v2021.0 onwards)</p></td><td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Select the required close parenthesis.&#160;</p><div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;"><p class="note">The open and close parenthesis allow you to create complex queries from the basic query condition option from the user interface.</p></div></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">Next Condition</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Select the appropriate value.&#160;The options are:</p><p class="table-text">• And - Select it to check all the conditions while registering a user.</p><p class="table-text">• OR - Select it to check only one of the conditions while registering a user.</p><div class="warning" MadCap:autonum="&lt;b&gt;Warning&lt;/b&gt;"><p class="note">When you use basic configuration, ensure that you set the last condition as 'AND for a single condition or multiple conditions. The rule will pickup the basic configuration correctly only if you set the last condition as 'AND'.</p></div></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td class="TableStyle-Default-Table-BodyD-Column1-Body1" style="text-align: left;" colspan="2"><p class="table-text"><strong>Action</strong> - To add additional actions, provide the parameter details and then click <strong>+Add Action</strong>.</p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">Organization Name</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Select one or more organization names to which the condition is applicable.</p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">Object Type</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Used to indicate the type of object to provision. For example, Endpoint or EndpointName::EntitlementType. Once the conditions in <strong>Object Type</strong> are met, the action specified in the <strong>Object</strong> attribute is triggered.&#160;</p><div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;"><p class="note">If you are unable to select the enterprise role while creating the technical rule,&#160;watch the <a href="../Resources/Attachments/User unable to find Enterprise Role while creating technical rule.mp4">Troubleshooting Video</a> to resolve it.</p></div></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">Object</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Value or name of the <strong>Object</strong> you want to provision. For example, a new account variable, name of entitlement, or the value of the enterprise role to an account. Objects are correspondingly selected for respective <strong>Object Types</strong>.&#160;</p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">Attribute</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Select the attribute as <strong>Assigned</strong> for the respective object type. For example, Account. A sample use-case scenario is employees who are permanent, assigning them account for a particular endpoint. For this, select Object Type as the application name (Endpoint), Object as Account and Attribute as Assigned.</p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">Birth Right</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Select&#160;Birth Right to provide access to the user for the respective organization and to create an account for the user matching the given condition.</p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">Remove Birthright Access if conditions fails</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Select this parameter to remove the granted birthright access if the condition fails. The Revoke tasks are created and once completed the access is revoked for the user. Only access is revoked when the conditions fails. The account is still retained for the respective endpoint.&#160;</p><p class="table-text"><strong>Use Case</strong>: Let us understand <strong>Remove Birthright Access if condition fails</strong> using the below example.</p><ul><li><p class="table-text">Condition: A condition is defined such as a userid by the name of 'jsmith' joins the organization (user is created in EIC) and is 'active'</p></li><li><p class="table-text">Action: Create an account for the user 'jsmith' in Active Directory (AD) and provide access to the user 'jsmith' for the 'ADGroup1'</p></li><li><p class="table-text">Birth Right: Account is created and Access is given to 'jsmith' user for 'ADGroup1' as soon as 'jsmith' joins and is active</p></li><li><p class="table-text">Remove Birthright Access if condition fails: After some time the userid is changed from 'jsmith' to 'kcpark'. This fails the condition given above as the userid is no longer 'jsmith' and it is changed to 'kcpark'. In this case, access for&#160;'ADGroup1' is revoked however the account for the user 'jsmith' still exists.</p></li></ul><div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;"><p class="note">Only roles assigned through birthright access and with the flag ‘<b>Remove Birthright access if the condition fails</b>’ are removed. Roles assigned through ARS request to a user (not through birthright), are still retained with the user when birthright condition fails for the respective user.</p></div></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">Detective</p></td><td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">From Release 5.5.0SP2 onwards, a new option <strong>Detective</strong> is added to the Technical Rule. In releases prior to 5.5.0SP2, the <strong>Detective&#160;</strong>flag was set in the database when you selected <strong>Evaluate Manager Hierarchy</strong> from the UI. The reason to provide <strong>Detective</strong> option in UI is it provides clarity that the Technical Rule has the Detective flag enabled.&#160;In addition, you need to run the <strong>DetectiveProvisioningRulesJob</strong> to check the condition and trigger actions.&#160;</p><p class="table-text">The Evaluate Manager Hierarchy option is dependent on the Detective flag. The Evaluate Manager Hierarchy option is visible, only after you select the <strong>Detective</strong> flag.</p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">Evaluate Manager Hierarchy</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">The <b>Evaluate Manager Hierarchy</b> flag is used to apply the Technical rule to a hierarchy of users. The evaluation of the manager's hierarchy is done when the user's secondary manager (2nd level manager) is specified in the Technical Rule condition and it matches the user's 2nd level manager.</p><p class="table-text">For example, a Technical Rule is created with conditions: User.Manager EQUALS 'SEC_MGR' and Users.City EQUALS 'NY' with action to create account in 'AD'.  The Detective flag is enabled along with <b>Evaluate Manager Hierarchy</b> for this Technical Rule. A user 'Primary_MGR' is reporting to Manager 'SEC_MGR'. A new user 'u2' is created with City as 'NY' and the immediate manager is 'Primary_MGR'.</p><p class="table-text"><b>Result</b>: When User 'u2' is created, it matches the condition of Secondary Manager ('SEC_MGR') defined in the Rule and City as NY'. When you run the job DetectiveProvisioningRulesJob, it checks the Detective flag and <b>Evaluate Manager Hierarchy</b> that are enabled and matches the conditions defined in rule. Tasks for a new account and access are created for the endpoint 'AD' for user 'u2'.</p><p class="table-text">To trigger the Evaluate Manager Hierarchy:</p><ol style="list-style-type: lower-alpha;"><li><p class="table-text">Create a Technical Rule as per the desired conditions and populate the values.</p></li><li><p class="table-text">Ensure that you first enable the <b>Detective</b> option.</p><p class="table-text">The Evaluate Manager Hierarchy is displayed after you enable the Detective option.</p></li><li><p class="table-text">Enable the '<b>Evaluate Manager Hierarchy</b>' option and save the Technical Rule.</p></li><li><p class="table-text">Click <b>Send for Approval</b>, to send the Technical Rule for approval.</p></li><li><p class="table-text">Ensure that the Technical rule is approved.</p></li><li><p class="table-text">Schedule or run the job <b>DetectiveProvisioningRulesJob</b>.</p></li></ol></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1"><p class="table-text">Preview</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1"><p class="table-text">Click <strong>Preview</strong> to view the users that are impacted before saving the Technical rule. A preview of the Technical rule is a draft and can be updated before you actually send the rule for approval.&#160;&#160;</p></td></tr><tr class="TableStyle-Default-Table-Body-Body1"><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyB-Column1-Body1"><p class="table-text">Send For Approval</p></td><td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyA-Column1-Body1"><p class="table-text">Click <strong>Send for Approval</strong> to send the newly created Technical rule for approval. A Request Id is created if there is a workflow associated within <strong>Global Config &gt; Identity Access Rules &gt; Rule Add Workflow</strong>. Once the rule is approved from Request Approval by the user as per the workflow created, the workflow is used.</p></td></tr></tbody></table></li>
            <li>On submission, the newly created technical rule details are available in <strong>Technical Rule.<br /></strong></li>
            <li>Create the Technical Rule job from&#160;<b>ADMIN &gt; Job Control Panel &gt; Utility &gt; Run Detective Rules and Take Action (DetectiveProvisioningRulesJob),</b> select <strong>Detective Technical Rules</strong> from the&#160;<strong>Execute Rules</strong> dialog box.</li>
            <li>Click <strong>Submit </strong>after the job is created.</li>
            <li>Once the condition is mapped in Technical Update Rule, pending tasks are created.</li>
            <li>
                <p class="auto-cursor-target">Schedule the WSRETRY job to complete pending tasks and perform provisioning or de-provisioning of identity objects to the target application. Based on the actions defined, birth-right accounts are created and access is provided to the specified endpoints. In addition, if&#160;<strong>Remove Birthright Access if conditions fails</strong> is selected and if the condition specified fails, the birthright access is removed.<br /></p>
                <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
                    <p class="note">If the technical rule does not trigger while onboarding users in EIC, watch the <a href="../Resources/Attachments/Technical rule does not trigger while onboarding users in SSM.mp4">Troubleshooting Video</a> to resolve it.</p>
                </div>
            </li>
        </ol>
        <h2 id="UploadingaTechnicalRule-ControllingAddAccessTasksforPrimaryAccountTypeinanEndpoint">Controlling Add Access Tasks for Primary Account Type in an Endpoint</h2>
        <p>The <strong>Primary Account Type</strong> parameter available in the <strong>Endpoint</strong> show page can be used for controlling add access tasks triggered from the Technical Rule. An Endpoint can have multiple account types in EIC. If a technical rule is triggered for a user with multiple accounts in different account types, you can restrict creating add access tasks only for the <strong>Primary Account type</strong> that is selected in an Endpoint and not for all account types. If no account type is marked as primary account type then Add Access task is created for all accounts with status as Active or&#160; Manually Provisioned. The technical rule can either be triggered either via User Import or Detective Rule Job or through User Update rule (via Rerun provisioning rule. Let us consider an example,&#160;an endpoint ‘EP1’ having two account types ‘P1’ and ‘P2’ in Endpoint ‘EP1’.&#160;</p>
        <p style="text-align: left;">The following points explain all scenarios:</p>
        <ul class="ak-ul" style="text-align: left;">
            <li>
                <p><strong>Primary Account Type selected is P1</strong>: When a technical rule gets triggered then add access tasks are created for <strong>only Primary Account type 'P1’</strong> in this example (and not for P2 account type).</p>
            </li>
            <li>
                <p><strong>Primary Account Type not selected in EP1 Endpoint</strong>: When a technical rule is triggered, add access tasks are created for all active or manually provisioned accounts for <strong>all account types </strong>(<strong>P1 and P2 in this example</strong>)</p>
            </li>
            <li>
                <p><strong>User is re-imported again and does not match Technical rule condition</strong>: Remove access tasks are created for <b>only those accounts (users assigned access for P1 account type)</b> that had matched the rule previously.</p>
            </li>
        </ul>
        <h2 id="UploadingaTechnicalRule-AssigningNewAccount,Access,orEnterpriseRoleBasedonDynamicValuesScenarios">Assigning New Account, Access, or Enterprise Role Based on Dynamic Values&#160;</h2>
        <p>While creating or updating a user based on Technical Rule defined using Object Type and Object, you can provision a new account to the user, provision access (entitlement) to an account or provision an Enterprise Role to the user based on the user attributes. Instead of defining multiple Technical Rules, you can achieve this by using a single Technical rule based on any user attribute. For example, user's city, custom property values of user, department name, and so on. To match the user attribute with the rule, use the Technical rule condition section, and use the Action section to define the action to perform when the condition is met. The <b>Object Type</b> field is where you can specify which type of object you want to provision. The <b>Object</b> indicates the value or name of the <b>Object</b> you want to provision. For example, <b>Object Type</b> can be Endpoint and Object will have the Account as the value. <b>Object Type</b> can be EntitlementType and the <b>Object</b> should have the name of the Entitlement which you want to provision.</p>
        <h3 id="UploadingaTechnicalRule-Scenario1:ProvisioningEnterpriseRolebasedonDynamicValues">Scenario 1: Provisioning Enterprise Role based on Dynamic Values</h3>
        <p>This scenario provides details about assigning an enterprise role to a user based on the dynamic value of 'City' to which the user belongs. For example, let’s assume there are three cities such as: 'LA', 'SFO' and 'Bangalore'. Analogous to these cities, there are three Enterprise Roles defined specifically for each of these 3 cities such as: 'LAFinance', 'SFOFinance', and 'BloreFinance' respectively already available under Roles list page. Now, based on the user's city, which can be&#160;'LA', 'SFO' or 'Bangalore', you want to assign the respective Enterprise Role:&#160;'LAFinance', 'SFOFinanace', and 'BangaloreFinance' to user when a user is created or updated in EIC.&#160;To achieve this, define the following parameters in the technical rule:</p>
        <ul>
            <li>Condition:<ul><li>Object: <strong>Users</strong></li><li>Attribute: <strong>City</strong></li><li>Condition:&#160;<strong>Not Equals</strong></li><li>Value:&#160;<strong>null</strong></li></ul></li>
            <li>Action<ul><li>Object Type:&#160;<strong>Enterprise Roles</strong></li><li>Object:&#160;<strong>${user.city}Finance</strong></li><li>Attribute: <strong>Assign</strong></li></ul></li>
        </ul>
        <p>Important attributes defined here are Object Type, which is Enterprise Roles and the Object: which dynamically defines the characters of city using the query, ${user.city}Finance. When a user's city is not null and based on value of user’s city such as 'LA', SFO', or 'Bangalore', respective enterprise role is assigned to the user&#160;'LAFinance', 'SFOFinanace', and 'BangaloreFinance'. User belonging to LA city for example, is assigned the role 'LAFinance'. Once the tasks are created and are completed for all the entitlements belonging to the Enterprise Role, the respective Enterprise Role is provisioned to the user.</p>
        <p>
            <img src="../Resources/Images/Assigning Enterprise Roles1.png" style="width: 1200px;height: 500px;" />
        </p>
        <h3 id="UploadingaTechnicalRule-Scenario2:ProvisioningAccess(Entitlements)basedonDynamicValues">Scenario 2: Provisioning Access (Entitlements) based on Dynamic Values</h3>
        <p>This scenario provides details of provisioning access (entitlement values) to a user for entitlement values belonging to a particular entitlement type and an endpoint when it matches the condition specified using the dynamic user attributes. For example, let’s assume that there are entitlement values such as: CN=HR,OU=AD (entitlementvalue1 value), CN=Finance,OU=AD (entitlementvalue2 value), and CN=Engineering,OU=AD (entitlementvalue3 value) belonging to an endpoint 'ADTest' and associated to an entitlement type 'Groups'. The departments available in the system are: HR, Finance, and Engineering, which are assigned to a user. There is already an existing Endpoint named 'ADTest' and an entitlement type 'Groups' with above-mentioned entitlement values available.</p>
        <p>Using this technical rule, you can assign the entitlement value to the user account for the respective department to which the user belongs, when a user is created or updated in EIC. To achieve this, define the following parameters in the technical rule:</p>
        <ul>
            <li>
                <p>Object Type: Specify <b>ENDPOINT::ENTITLEMENTTYPE</b> from which you want to assign the entitlement to the user.</p>
            </li>
            <li>
                <p>Object: specify the <b>CN=${user.departmentname},OU=AD</b> custom query.</p>
            </li>
            <li>
                <p>Attribute: Select <b>Assign</b>.</p>
            </li>
        </ul>
        <p>The critical parameter <b>Object</b> checks dynamic values of user's departmentname (using the user.departmentname) such as HR, Finance, and Engineering to which user belongs and accordingly assigns the respective entitlement for the particular department. For example, when a user joins the HR department then based on the query, the entitlementvalue1 value CN=HR,OU=AD is assigned to the user for <b>Groups</b> entitlement type and ADTest endpoint. Once the tasks are created and are completed for all the entitlements, the respective entitlements are provisioned to the user account.</p>
        <p style="margin-left: 0.0cm;">
            <img src="../Resources/Images/Provisioning Access based on Dynamic Values2.png" style="border-left-style: solid;border-left-width: 1px;border-left-color: ;border-right-style: solid;border-right-width: 1px;border-right-color: ;border-top-style: solid;border-top-width: 1px;border-top-color: ;border-bottom-style: solid;border-bottom-width: 1px;border-bottom-color: ;width: 1200px;height: 500px;" />
            <br />
        </p>
        <h3 id="UploadingaTechnicalRule-Scenario3:ProvisioningAccountandAccessbasedonDynamicValues">Scenario 3: Provisioning Account and Access based on Dynamic Values</h3>
        <p>This scenario provides details of provisioning account and access (entitlement values) for a user, using dynamic queries for both&#160;<strong>Object Type</strong>&#160;and&#160;<strong>Object</strong>. The query for populating dynamically the Endpoint and Entitlement Type is discussed in this example. Let us assume that&#160;SaviyntTest&#160;is an existing Endpoint with Entitlement Types:&#160;Functions and SAVRoles&#160;in the system. The requirement is to create an account in endpoint&#160;SaviyntTest&#160;when the user's street name 'SaviyntTest'. If you want to create an account in an endpoint in EIC dynamically then you need to use the syntax for example: SAVENDPOINT::${user.street} in&#160;<strong>Object Type</strong>. This syntax checks the user's street name which exactly matches the Endpoint name in EIC and creates a new account task for the user in the respective matched endpoint.</p>
        <p>If you want to add access along with the new account, which was created in the previous section then you can specify the query as discussed in this section. The query for populating dynamically the Entitlement Type is, for example, SAVENTTYPE::${user.street}::${user.middlename} in&#160;<strong>Object Type</strong>. The first part of the syntax&#160;SAVENTTYPE::${user.street} is EndpointName determined in the previous section. Once endpoint name is identified, using the&#160;${user.middlename} the entitlement type is determined. For example, entitlementtype would be Functions if user’s middlename is “Functions” and would be “SAVRoles” if user’s middlename is “SAVRoles”. Add access task gets created for access name matching ${user.city} belonging to the entitlement type as mentioned in <strong>ObjectType</strong>. The&#160;<strong>Object</strong>&#160;field must have the dynamic query for the access name to match.</p>
        <p>To fetch dynamic entitlement values in&#160;<strong>Object</strong>, you can specify dynamic query as ${user.city}. If there are 2 entitlement values: BLR and NY belonging to entitlement type Functions and if the user's city mentioned is BLR, then access BLR of entitlementtype Functions is provisioned to the user account in the SaviyntTest Endpoint. Similarly, you can specify multiple dynamic queries sequentially and assign entitlement values also dynamically.&#160;Once the tasks are created and are completed for the add account task and add entitlement tasks, the account is created in the respective endpoint and access are added to the user’s account.&#160;&#160;</p>
        <p>
            <img src="../Resources/Images/Provisioning Account and Access based on Dynamic Values3.png" style="border-left-style: solid;border-left-width: 1px;border-left-color: ;border-right-style: solid;border-right-width: 1px;border-right-color: ;border-top-style: solid;border-top-width: 1px;border-top-color: ;border-bottom-style: solid;border-bottom-width: 1px;border-bottom-color: ;" />
        </p>
        <h3 id="UploadingaTechnicalRule-Scenario4:UsingCustomQuerytoFetchEntitlementValues">Scenario 4: Using Custom Query to Fetch Entitlement Values</h3>
        <p>This scenario provides details of provisioning access (entitlement values) for a user, using custom query for&#160;<strong>Object</strong>. Let us assume that SaviyntTest is an existing Endpoint with Entitlement Types:&#160;Functions and SAVRoles&#160;in the system. The&#160;<strong>Object Type</strong>&#160;is used to identify the Entitlement Type. The syntax for&#160;<strong>Object Type</strong>&#160;is given as: SAVENTTYPE::${user.street}::${user.middlename}. Using this syntax, user(s) with street 'SaviyntTest' and middlename as Functions enables mapping and identifying that entitlement value to be added for the Functions entitlement type belonging to SaviyntTest Endpoint.</p>
        <p>The second part is the&#160;<strong>Object</strong>&#160;where the custom query to fetch entitlement value(s) is specified. Let us assume that the requirement is to assign entitlement values: entValSAP, entValOracle, and entValSAPHR belonging to Entitlement Type Functions for Endpoint SaviyntTest. The syntax to specify the custom query starting with entVal and followed by any other characters is:&#160;SAVCUSTOMQUERY::ev.entitlement_value like 'entVal%'. Hence, the three entitlement values starting with entValSAP, entValOracle and&#160;entValSAPHR belonging to Entitlement Type Functions in Endpoint&#160;SaviyntTest are assigned to the user. Similarly, if you want to specify custom query matching the entitlement value containing 'LA' in the end of the entitlement name string, you can specify the custom query as&#160;SAVCUSTOMQUERY::ev.entitlement_value like '%LA'. For, specifying custom query with 'LA' characters anywhere in the string of entitlement value, specify the custom query as&#160;SAVCUSTOMQUERY::ev.entitlement_value like '%LA%'.&#160;Once the tasks are created and are completed for all the entitlements, the respective entitlements are provisioned.</p>
        <p>
            <img src="../Resources/Images/Provisioning and Filtering Entitlement Values Using Custom Query1.png" style="border-left-style: solid;border-left-width: 1px;border-left-color: ;border-right-style: solid;border-right-width: 1px;border-right-color: ;border-top-style: solid;border-top-width: 1px;border-top-color: ;border-bottom-style: solid;border-bottom-width: 1px;border-bottom-color: ;width: 1200px;height: 400px;" />
        </p>
        <h3 id="UploadingaTechnicalRule-Scenario5:AssigningEnterpriseRolewhenauserjoinstheorganization">Scenario 5: Assigning Enterprise Role when a user joins the organization</h3>
        <p>You can also assign Enterprise Roles to a user through Technical Rules. For example, you can assign an Enterprise Role to a user if the user's start date is less than the current system date AND for active users. This means when the user joins the organization and for active users, the user's account is created in an endpoint, and entitlements belonging to the Enterprise Role are assigned to it. Whenever the user's status changes to inactive and it fails to meet the condition, the Enterprise Role assigned to the user is removed.&#160;</p>
        <p>To accomplish this using Technical Rule, select the following items in the condition:</p>
        <ul>
            <li>Specify two conditions:<ul><li>Condition 1:<ul><li>Select Object as: Users</li><li>Attribute as: Start Date</li><li>Condition as: Less than</li><li>Value as:&#160;sysdate() OR DATE_ADD(curdate(),INTERVAL 1 DAY) OR DATE_SUB(curdate(),INTERVAL 1 DAY), and so on.</li></ul></li><li>Condition 2:&#160;<ul><li>Select Object as: Users</li><li>Attribute as: statuskey</li><li>Condition as: Equals</li><li>Value as: 1 (which means active users)</li></ul></li></ul></li>
        </ul>
        <p>Ensure you select Enterprise Role in Action as follows:</p>
        <ul>
            <li>
                <p>Object Type as Enterprise Role</p>
            </li>
            <li>
                <p>Object: Name of Enterprise Role</p>
            </li>
            <li>
                <p>Attribute: Assign</p>
            </li>
        </ul>
        <p>Select the <strong>Birth Right</strong> checkbox to assign the user an enterprise role as soon as the user joins the organization. You will be given an additional option to select <strong>Remove Birthright Access if condition fails</strong>. If you want to revoke Enterprise Role from the user, if the condition fails, select the <strong>Remove Birthright Access if condition fails</strong> option.&#160;&#160;</p>
        <p><strong>Result</strong>: When the user joins the organization, the respective Enterprise Role selected is assigned to the user. When the user is no longer with active status and it fails the condition (user status equals 1), the birthright Enterprise role assigned to user is revoked.</p>
        <p>
            <img src="../Resources/Images/condition3.png" style="border-left-style: solid;border-left-width: 1px;border-left-color: ;border-right-style: solid;border-right-width: 1px;border-right-color: ;border-top-style: solid;border-top-width: 1px;border-top-color: ;border-bottom-style: solid;border-bottom-width: 1px;border-bottom-color: ;width: 1200px;height: 500px;" />
        </p>
    </body>
</html>